#pragma once
#include <opencv2/highgui/highgui.hpp>
#include <string>
#include <iostream>
#include "Obra.h" 
#include "DadesMuseus.h" 
#include "Resultat.h"

using namespace cv;
using namespace std;

class Classificador
{
public:

	// constructors
	Classificador(void); 
	Classificador(string dbPath, int p_num_folds, int p_num_class_per_fold, int p_feature_type, int p_num_veins, bool p_debug);
	~Classificador(void);  

	// executa el process de classificaci
	void run(); 
private: 

	CDadesMuseus m_dm;
	int m_num_res;
	int m_num_folds;
	int m_num_class_per_fold;
	bool m_debug;
	int m_num_veins;

	map<int,Resultat> m_resultats;  
	//map<int,int> m_matriuconfusio;    
	
   // determina si un determinat fold es valid per assignar a una obra en funcion de 
   // la seva classe: volem que els k-folds tinguin el mateix nombre de representants 
   // de cada classe 
   bool isValidFold(int fold_num, int a_classID);

   // determina la obra mes propera a una donada
   // fa servir la nocio de distancia encapsulada en el metode distancia
   // de la classe obra
   Obra getObraMesPropera(Obra obr); 
	
   // split into folds
   void spliIntoFolds(void);  

   // set one fold as test set and the other as trainning
   void setTestSet(int foldId); 

   // classification
   void classifyTestSet(void);

   void setDM(CDadesMuseus dm);

   	void showAllImages(void); 
    void showTrainningAndTestSets(void);     
	void showFolds(void);  
	int showResult(bool detallat);  

	// getters
	// int getResultsClass(int classValue); 
	int getNumFolds(void); 
	int getNumClass_per_fold(void);

};

